module mgempak

!--------------------------------------------------------------------------
!									   
!                Modulo de Leitura e Escrita de Arquivos de Dados 	   
! 
! Autores:Sergio Henrique S. Ferreira  - 31/08/2004 
!         Ana Lucia Travezani Ferreira 
!
!
!

!save_mgempak- Salva Dados em Formato Texto para Gempak
!
!---------------------------------------------------------------------------

contains

  subroutine save_mgempak(un,file,obs,nobs,varname,nvar,gdate)
  
   

    integer,intent(in)	 			::un    !  Unidade de gravacao de arquivo
    character(len=*),intent(in)			::file  !  Nome do arquivo de gravacao 
    real,dimension(:,:),intent(inout)		::obs   !  Matriz de dados
    integer,intent(in)				::nobs  !  Numero de linhas de obs
    character(len=*),dimension(:),intent(in) 	::varname  !  Nome das variaveis
    integer,intent(in)          		::nvar  !  Numero de variaveis(ncod)
    character(len=*),dimension(:),intent(in)	::gdate !  Datas do arquivo 
    
    
!--------------------- Variaveis Locais ---------------------    
   
    character(len=255)::aux$,aux2$  
    			
    integer i,j
    
    real :: varObs=-340200300 	!  Valor nulo para Estacoes
    
!------------------------------------------------------------
 
    
    open(un,file=file,status='unknown')
    
   
    
!##################### Inicio Cabecalho ######################

   aux$='PARM='
            
	    do I=1,nvar
               aux$=trim(aux$)//varname(i)//";"
	       
	      
            end do
            
             write(un,'(a)')trim(aux$)

  
  
  
   aux$='YYYYMMDD/HHMM'
   
   do i=1,nvar
   	
	aux$=trim(aux$)//"     "//varname(i)
   
   end do
    
    write(un,'(a)')trim(aux$)
    
   
!##################### Fim Cabecalho #########################    



   
   
!############### Inicio Gravacao de Dados ####################   
    
    do i=1,nobs    	
	aux$=gdate(i)
	do j=1,nvar
	
		if(obs(i,j)<=varObs) then
			aux2$=' 99999.99'
			
		else
			write(aux2$,'(1x,f8.2)')obs(i,j)
		end if	
	
	aux$=trim(aux$)//aux2$
	end do
	write(un,'(a)')trim(aux$)
    end do
    
!################# Fim Gravacao de Dados ######################    		

	
  close(un)
  end subroutine

end module
 
